diff -urN asterisk-10.12.0-orig/main/asterisk.c asterisk-10.12.0-astcanary/main/asterisk.c
--- asterisk-10.12.0-orig/main/asterisk.c	2012-12-03 23:53:58.000000000 +0100
+++ asterisk-10.12.0-astcanary/main/asterisk.c	2013-01-17 11:32:32.805741133 +0100
@@ -3788,6 +3788,8 @@
 #ifndef HAVE_SBIN_LAUNCHD
 		if (daemon(1, 0) < 0) {
 			fprintf(stderr, "daemon() failed: %s\n", strerror(errno));
+		} else {
+			ast_mainpid = getpid();
 		}
 #else
 		fprintf(stderr, "Mac OS X detected.  Use 'launchctl load /Library/LaunchDaemon/org.asterisk.asterisk.plist'.\n");
@@ -3839,11 +3841,10 @@
 	}
 
 	/* Blindly write the PID file. */
-	ast_mainpid = getpid();
 	unlink(ast_config_AST_PID);
 	f = fopen(ast_config_AST_PID, "w");
 	if (f) {
-		fprintf(f, "%ld\n", (long)getpid());
+		fprintf(f, "%ld\n", (long)ast_mainpid);
 		fclose(f);
 	} else {
 		fprintf(stderr, "Unable to open pid file '%s': %s\n", ast_config_AST_PID, strerror(errno));
